#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "fire800one4xi.py">
#<abstract4xi abstract = "fires to direction one and to distance 800"/>
#<verify4xi verification = "11" target = "verb4xi.py"/>
#<refer4xi reference = "verb4xi.py"/>
#<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'fire800one4xi']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread   

import signal
import itertools
import weakref
import logging 

from math import pi
from math import sin
from math import cos 
from math import fabs
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "


from time4xi import time4xi

#"
#/>

# -------------------------------------------------------------------------------------------------
# Global constants                            
# ------------------------------------------------------------------------------------------------
#<globalize4xi globalization = "

       
# -------------------------------------------------------------------------------------------------
# SHOT2ONE - COORDINATE SIGNS OF SHOOT2ONE4XI: (X + ,Y + ,Z + )
# -------------------------------------------------------------------------------------------------  

global shot2one8004xi

#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings - copied from load2one4xi.py results to access faster by verb4xi.py
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ack2debug = False 


                                    
# -------------------------------------------------------------------------------------------------
# 800
# -------------------------------------------------------------------------------------------------                                          
shot2one8004xi = {
                  1:'0x0y799z',
                  2:'0x16y799z',
                  3:'0x1y799z',
                  4:'0x24y799z',
                  5:'0x529y599z',
                  6:'0x8y799z',
                  7:'100x732y304z',
                  8:'105x494y620z',
                  9:'109x700y369z',
                  10:'113x584y533z',
                  11:'113x646y457z',
                  12:'11x20y799z',
                  13:'11x669y437z',
                  14:'11x79y796z',
                  15:'129x482y625z',
                  16:'138x723y312z',
                  17:'13x70y796z',
                  18:'142x572y539z',
                  19:'145x690y376z',
                  20:'146x634y464z',
                  21:'14x28y799z',
                  22:'152x468y630z',
                  23:'15x36y798z',
                  24:'15x61y797z',
                  25:'16x45y798z',
                  26:'16x53y798z',
                  27:'171x559y545z',
                  28:'174x454y635z',
                  29:'175x712y319z',
                  30:'177x621y470z',
                  31:'180x678y384z',
                  32:'195x438y639z',
                  33:'198x544y551z',
                  34:'208x607y477z',
                  35:'211x698y326z',
                  36:'214x664y391z',
                  37:'215x422y644z',
                  38:'21x611y515z',
                  39:'224x528y557z',
                  40:'233x404y649z',
                  41:'238x591y483z',
                  42:'23x0y799z',
                  43:'23x745y289z',
                  44:'246x683y334z',
                  45:'247x648y397z',
                  46:'249x510y562z',
                  47:'250x386y654z',
                  48:'25x19y799z',
                  49:'266x367y658z',
                  50:'267x573y489z',
                  51:'272x492y568z',
                  52:'279x630y404z',
                  53:'27x522y604z',
                  54:'280x666y341z',
                  55:'281x347y663z',
                  56:'294x327y667z',
                  57:'294x554y496z',
                  58:'295x472y574z',
                  59:'306x306y671z',
                  60:'30x26y799z',
                  61:'310x611y411z',
                  62:'313x648y348z',
                  63:'316x451y579z',
                  64:'317x285y676z',
                  65:'320x533y502z',
                  66:'326x264y680z',
                  67:'334x243y684z',
                  68:'335x429y585z',
                  69:'339x590y418z',
                  70:'345x512y508z',
                  71:'345x627y355z',
                  72:'34x33y798z',
                  73:'353x407y590z',
                  74:'368x489y514z',
                  75:'368x568y425z',
                  76:'36x715y355z',
                  77:'370x383y596z',
                  78:'375x605y362z',
                  79:'385x359y601z',
                  80:'38x40y798z',
                  81:'390x465y520z',
                  82:'394x545y432z',
                  83:'399x335y606z',
                  84:'3x95y794z',
                  85:'404x582y369z',
                  86:'410x440y526z',
                  87:'411x310y611z',
                  88:'41x48y797z',
                  89:'420x520y438z',
                  90:'422x284y616z',
                  91:'429x414y532z',
                  92:'432x557y377z',
                  93:'43x57y796z',
                  94:'443x494y445z',
                  95:'446x388y538z',
                  96:'44x66y796z',
                  97:'458x531y384z',
                  98:'461x360y544z',
                  99:'465x467y452z',
                  100:'46x663y444z',
                  101:'475x333y550z',
                  102:'483x503y391z',
                  103:'486x439y458z',
                  104:'4x6y799z',
                  105:'505x410y465z',
                  106:'505x474y398z',
                  107:'50x84y894z',
                  108:'522x380y471z',
                  109:'527x445y404z',
                  110:'52x604y521z',
                  111:'546x414y411z',
                  112:'54x514y610z',
                  113:'62x740y297z',
                  114:'73x709y362z',
                  115:'7x87y795z',
                  116:'80x505y615z',
                  117:'80x655y451z',
                  118:'83x595y527z',
                  119:'8x13y799z'}

#"
#"/>
    

# -------------------------------------------------------------------------------------------------
#<function4xi function = "fire800one4xi" usage = "target function for chargeone4xi with Process4Xi">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def fire800one4xi(queue2one, consumer_channel2one, publisher_channel2one):
    '''
    returns (x,y,z) coordinates via queue
    '''
    
    # -------------------------------------------------------------------------------------------------
    # PARAMETERS                   
    # -------------------------------------------------------------------------------------------------                                                               
    
    time2start = time4xi()
    if ack2debug is True:
        print("\n (STEP 1A1/33) OF FIRE80ONE4XI - STARTED TIME: ", time2start)
        # 
        
        print("\n (STEP 1A2/33) OF FIRE80ONE4XI -  QUEUE2ONE: ", queue2one)      
        # 
        
        print("\n (STEP 1A3/33) OF FIRE80ONE4XI -  CONSUMER_CHANNEL2ONE: ", consumer_channel2one)
        # 
              
        print("\n (STEP 1A4/33) OF FIRE80ONE4XI -  PUBLISHER_CHANNEL2ONE: ", publisher_channel2one)          
        # 
        


    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # QUEUE RETURNING
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ack2put = False
    if ack2debug is True:
        print("\n (STEP 2A/33) OF FIRE80ONE4XI - TRYING TO RETURN BY PUTTING SHOT2ONE8004XI TO QUEUE2ONE: ", queue2one, " - TIME: ", time4xi()) 
        # 
         
    try:
        # ------------------------------------------------------------------------------------- 
        # PUT SHOT TO QUEUE 
        # -------------------------------------------------------------------------------------                 
        queue2one.put(shot2one8004xi)
        if ack2debug is True:
            print("\n (STEP 2B/33) OF FIRE80ONE4XI - SUCCEEDED TO PUT SHOT2ONE8004XI TO QUEUE2ONE: ", queue2one, " - TIME: ", time4xi()) 
            # SUCCEEDED TO PUT SHOT2ONE8004XI TO QUEUE2ONE:  <queue4xi.Queue4Xi object at 0x02AF7090>  - TIME:  23:45:06 08/24/10 Pacific Daylight Time  
             
        ack2put = True
    except:
        print("\n (STEP 2C/33) OF FIRE80ONE4XI *** FAILED TO PUT SHOT2ONE8004XI TO QUEUE2ONE: ", queue2one, " - TIME: ", time4xi()) 
    
    if ack2debug is True:
        print("\n (STEP 3A/33) OF FIRE80ONE4XI - TRYING TO INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER_CHANNEL2ONE: ", publisher_channel2one, " - TIME: ", time4xi())
        #
         
    if ack2put is True:
        message2send4one = "<ack2put4xi>queue2one8shot2one8004xi</ack2put4xi>"
    else:
        message2send4one = "<nack2put4xi>queue2one8shot2one8004xi</nack2put4xi>" 
                     
    try:                
        # ---------------------------------------------------------------------------------------------
        # INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER CHANNEL 
        # ---------------------------------------------------------------------------------------------

        publisher_channel2one.send(message2send4one)
        if ack2debug is True:    
            print(" (STEP 3B/33) OF FIRE80ONE4XI -  SENT MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2ONE: ", publisher_channel2one, " - TIME: ", time4xi()) 
            # SENT MESSAGE2SEND4ONE:  <ack2put4xi>queue2one8shot2one8004xi</ack2put4xi>  TO PUBLISHER_CHANNEL2ONE:  <read-write PipeConnection, handle 260>  - TIME:  23:45:06 08/24/10 Pacific Daylight Time
        
    except:
        print(" (STEP 3C/33) OF FIRE80ONE4XI *** FAILED TO SEND MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2ONE: ", publisher_channel2one, " - TIME: ", time4xi()) 
    
    if ack2debug is True:        
        print("\n (STEP 3D/33) OF FIRE80ONE4XI - RETURNING QUEUE OBJECT QUEUE2ONE: ", queue2one, " - TIME: ", time4xi())  
        # 
            
    return queue2one    
        
           
#</function4xi>


#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_verb4xi.txt
#   sense-test-verb4xi.xml
#   reason-test-verb4xi.xml
#   ace-test-verb4xi.xml
#"
#>



# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of fire800one4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
